<?php
// +--------------------------------------------------------------------------+
// | PayPal Plugin - geeklog CMS                                             |
// +--------------------------------------------------------------------------+
// | index.php                                                                |
// |                                                                          |
// | Admin index page for the paypal plugin.  By default, lists products      |
// | available for editing                                                    |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | Copyright (C) 2005-2006 by the following authors:                        |
// |                                                                          |
// | Authors: Vincent Furia     - vinny01 AT users DOT sourceforge DOT net    |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | This program is free software; you can redistribute it and/or            |
// | modify it under the terms of the GNU General Public License              |
// | as published by the Free Software Foundation; either version 2           |
// | of the License, or (at your option) any later version.                   |
// |                                                                          |
// | This program is distributed in the hope that it will be useful,          |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with this program; if not, write to the Free Software Foundation,  |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.          |
// |                                                                          |
// +--------------------------------------------------------------------------+


/**
 * Admin index page for the paypal plugin.  By default, lists products available for editing
 *
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @copyright Vincent Furia 2005 - 2006
 * @package paypal
 */

/**
 * Required geeklog
 */
require_once('../../../lib-common.php');

// Check for required permissions
paypal_access_check('paypal.admin');

$vars = array('msg', 'text');
paypal_filterVars($vars, $_REQUEST);

function PAYPAL_listProducts()
{
    global $_CONF, $_TABLES, $_IMAGE_TYPE, $LANG_ADMIN, $LANG_PAYPAL_1;

    require_once $_CONF['path_system'] . 'lib-admin.php';

    $retval = '';
	
	if (DB_count($_TABLES['paypal_products']) == 0){
	return $retval = '';
	}

    $header_arr = array(      // display 'text' and use table field 'field'
        array('text' => $LANG_ADMIN['edit'], 'field' => 'edit', 'sort' => false),
		// Maybe later a clone option
        //array('text' => $LANG_ADMIN['copy'], 'field' => 'copy', 'sort' => false),
        array('text' => $LANG_PAYPAL_1['id'], 'field' => 'id', 'sort' => true),
        array('text' => $LANG_PAYPAL_1['name_list'], 'field' => 'name', 'sort' => true),
        array('text' => $LANG_PAYPAL_1['description_list'], 'field' => 'short_description', 'sort' => true),
        //array('text' => $LANG_PAYPAL_1['active_field'], 'field' => 'active', 'sort' => true),
        //array('text' => $LANG_PAYPAL_1['hidden_field'], 'field' => 'hidden', 'sort' => true)
    );
    $defsort_arr = array('field' => 'id', 'direction' => 'asc');

    $text_arr = array(
        'has_extras' => true,
        'form_url' => $_CONF['site_admin_url'] . '/plugins/paypal/index.php'
    );
	
	$sql = "SELECT
	            *
            FROM {$_TABLES['paypal_products']}";

    $query_arr = array(
        'table'          => 'paypal_products',
        'sql'            => $sql,
        'query_fields'   => array('name', 'short_description'),
        'default_filter' => COM_getPermSQL ('AND', 0, 3)
    );

    $retval .= ADMIN_list('paypal', 'plugin_getListField_paypal',
                          $header_arr, $text_arr, $query_arr, $defsort_arr);

    return $retval;
}

/**
*   Get an individual field for the paypal screen.
*
*   @param  string  $fieldname  Name of field (from the array, not the db)
*   @param  mixed   $fieldvalue Value of the field
*   @param  array   $A          Array of all fields from the database
*   @param  array   $icon_arr   System icon array
*   @param  object  $EntryList  This entry list object
*   @return string              HTML for field display in the table
*/
function plugin_getListField_paypal($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG_ADMIN, $LANG_STATIC, $_TABLES, $_PAY_CONF;

    switch($fieldname) {
        case "edit":
		    $edit_url = $_CONF['site_admin_url'] . '/plugins/paypal/product_edit.php?op=edit&amp;id=' . $A['id'];
            $retval = COM_createLink($icon_arr['edit'], $edit_url);
            break;
        case "name":
            $url = $_PAY_CONF['site_url'] .
                                 '/product_detail.php?product=' . $A['id'];
            $retval = COM_createLink($A['name'], $url, array('title'=>$LANG_PAYPAL_1['title_display']));
            break;
        case "id":
            $retval = $A['id'];
            break;
		/*case "active":
            if ($fieldvalue == 1) {
			$retval = '<img src="'. $_CONF['site_admin_url'] . '/plugins/maps/images/green_dot.gif" alt="" valign="center">';
			} else {
			$retval = '<img src="'. $_CONF['site_admin_url'] . '/plugins/maps/images/red_dot.gif" alt="">';
			}
            break;
		case "hidden":
            if ($fieldvalue == 0) {
			$retval = '<img src="'. $_CONF['site_admin_url'] . '/plugins/maps/images/green_dot.gif" alt="">';
			} else {
			$retval = '<img src="'. $_CONF['site_admin_url'] . '/plugins/maps/images/red_dot.gif" alt="">';
			}
            break; */
        default:
            $retval = stripslashes($fieldvalue);
            break;
    }
    return $retval;
}

//Main

$display = COM_siteHeader();
$display .= paypal_admin_menu();

if (!empty($_REQUEST['msg'])) {
    $display .= COM_startBlock($LANG_PAYPAL_1['message']);
    $display .= stripslashes($_REQUEST['msg']);
    $display .= COM_endBlock();
}
$display .= '<img src="' . $_PAY_CONF['site_url'] . '/images/paypal.gif" alt="" align="left" hspace="10">' 
		 . '<p>' .$LANG_PAYPAL_1['plugin_doc'] . ' <a href="http://geeklog.fr/wiki/plugins:paypal" target="_blank">'. $LANG_PAYPAL_1['online']
		 . '</a>.</p>'
		 . '<p> ' . $LANG_PAYPAL_1['plugin_conf'] . ' <a href="' . $_CONF['site_admin_url'] . '/configuration.php">'. $LANG_PAYPAL_1['online']
		 . '</a>.</p>';
$display .= '<br /><h1>' . $LANG_PAYPAL_1['products_list'] . '</h1>';
$display .= '<p>' . $LANG_PAYPAL_1['you_can'] . '<a href="' . $_CONF['site_url'] . '/admin/plugins/paypal/product_edit.php">' . $LANG_PAYPAL_1['create_product'] . '</a>.</p>';

$display .= PAYPAL_listProducts();

$display .= COM_siteFooter();

COM_output($display);

?>