<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Paypal Plugin 1.1                                                         |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API methods and 2) implements all the common code needed by this plugin.  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: ::Ben - cordiste AT free DOT fr                                  |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// | Based on the original paypal Plugin                                       |
// | Copyright (C) 2005 - 2006 by the following authors:                       |
// |                                                                           |
// | Vincent Furia <vinny01 AT users DOT sourceforge DOT net>                  |   
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
 * paypal plugin functions.inc file
 *
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @copyright Vincent Furia 2005 - 2006
 * @package paypal
 */

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die ('This file can not be used on its own.');
}

/**
 * Throw in uid = 1 for anonymous users
 */
if ( empty($_USER['uid']) ) {
    $_USER['uid'] = 1;
    $_USER['username'] = 'anonymous';
    $_USER['fullname'] = 'Anonymous';
}

/**
 * Language file include
 */
$plugin_path = $_CONF['path'] . 'plugins/paypal/';
$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';

if (file_exists($langfile)) {
    require_once $langfile;
} else {
    require_once $plugin_path . 'language/english.php';
}

/**
 * Load our config
 */
require_once $_CONF['path_system'].'classes/config.class.php';
$c = config::get_instance();
$_PAY_CONF = $c->get_config('paypal');

/*
* Include specific paypal config file
*/
require_once ($_CONF['path'] . 'plugins/paypal/paypal.php');

/*
* Include classes
*/
require_once ($_CONF['path'] . 'plugins/paypal/classes/jcart.class.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementation                                         |
// +---------------------------------------------------------------------------+

function plugin_getheadercode_paypal()
{
	global $_CONF, $_PAY_CONF;
	
	$base_uri = $_PAY_CONF['site_url'];
	
	if(!defined('JQUERY')){
        $retval .= '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>'. LB;
		$retval .= '<script>
    if(jQueryNoConflict == undefined){
    jQuery.noConflict();
    var jQueryNoConflict = true;
    }
</script>'. LB;

        define('JQUERY', 'true');
    }	

	$retval .= LB . '<link rel="stylesheet" type="text/css" href="'
			. $base_uri . '/css/paypal.css?vers=1.1"' . XHTML . '>' . LB
			. '<link rel="stylesheet" type="text/css" href="'
			. $base_uri . '/css/jcart.css?vers=1.1"' . XHTML . '>' . LB
			. '<script type="text/javascript" src="'
			. $base_uri . '/js/jcart-javascript.php?vers=1.1"></script>';
	return $retval;
}


/**
* Returns the item(s) for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* @return   mixed   menu entry, or boolean false if disabled / hidden
*
*/
function plugin_getmenuitems_paypal()
{
    global $_PAY_CONF, $_USER;

    $menuitems = array();
  	if ($_PAY_CONF['hide_paypal_menu'] == 0)  {
	    if  ($_USER['uid'] < 2 && $_PAY_CONF['paypal_login_required'] == 1) {
		    return $menuitems;
		} else {
      	    $menuitems[$_PAY_CONF['menulabel']] = $_PAY_CONF['site_url'] . '/index.php';
		}
    }
    return $menuitems;
}

/**
* Returns doc uri for Geeklog-1.6.0 or later
*/
function plugin_getdocumentationurl_paypal() {
	
	return 'http://geeklog.fr/wiki/plugins:paypal#configuration';
}

/**
* Implements a [paypal:] autotag.
*
* @param    string  $op         operation to perform
* @param    string  $content    item (e.g. story text), including the autotag
* @param    array   $autotag    parameters used in the autotag
* @param    mixed               tag names (for $op='tagname') or formatted content
*
*/

function plugin_autotags_paypal($op, $content = '', $autotag = '')
{
    global $_CONF, $_TABLES, $LANG_PAYPAL_1, $_PAY_CONF;

    if ($op == 'tagname') {
        return 'paypal';
    } elseif ($op == 'parse') {
        $pid = COM_applyFilter($autotag['parm1']);
        if (! empty($pid)) {
            $url = $_PAY_CONF['site_url'] . '/product_detail.php?product=' . $pid;
            if (empty($autotag['parm2'])) {
                $linktext = 'Paypal'; // or get title from db
            } else {
                $linktext = $autotag['parm2'];
            }
            $link = COM_createLink($linktext, $url);
            $content = str_replace($autotag['tagstr'], $link, $content);
        }

        return $content;
    }
}


/**
* Return plugin entry for "Command and Control" (moderation.php)
*
* @return  array  Array containing (plugin name, admin url, url of plugin icon)
*/

function plugin_cclabel_paypal()
{
    global $_CONF, $LANG_PAYPAL_1;

    $retval = array();
    if (SEC_hasRights('paypal.admin')) {
        $retval = array($LANG_PAYPAL_1['plugin_name'],
            $_CONF['site_admin_url'] . '/plugins/paypal/index.php',
            plugin_geticon_paypal());
    }

    return $retval;
}

/**
* Return plugin entry for the Admins Only block
*
* @return array Array containing (plugin name, plugin admin url, # of plugin items or '')
*/
function plugin_getadminoption_paypal()
{
    global $_CONF, $LANG_PAYPAL_1;

    if (SEC_hasRights('paypal.admin')) {
        return array($LANG_PAYPAL_1['plugin_name'],
            $_CONF['site_admin_url'] . '/plugins/paypal/index.php', 0);
    }
}

/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/
function plugin_geticon_paypal()
{
    global $_PAY_CONF;

    return $_PAY_CONF['site_url'] . '/images/paypal.gif';
}

/**
 * Returns the current plugin code version
 *
 * @return string    plugin version
 */
function plugin_chkVersion_paypal()
{
    global $_CONF;

    require_once $_CONF['path'] . 'plugins/paypal/autoinstall.php';

    $inst_parms = plugin_autoinstall_paypal('paypal');

    return $inst_parms['info']['pi_version'];
}

/**
* Update the plugin
*
* @return   int     Number of message to display or true for success
*
*/
function plugin_upgrade_paypal()
{
    global $_CONF, $_TABLES, $_USERS, $_DB_dbms;

    $currentVersion = DB_getItem($_TABLES['plugins'], 'pi_version',
                                    "pi_name = 'paypal'");
    $code_version = plugin_chkVersion_paypal();
    if ($currentVersion == $code_version) {
        // nothing to do
        return true;
    }

    require_once $_CONF['path'] . 'plugins/paypal/autoinstall.php';
	require_once $_CONF['path'] . 'plugins/paypal/sql/'
                                . $_DB_dbms . '_updates.php';

    if (! plugin_compatible_with_this_version_paypal('paypal')) {
        return 3002;
    }

    // other update code goes here

    switch( $currentVersion ) {
        
		case '0.1rc1':
		case '0.1' :
		case '0.1.1':
		case '0.2' :
			DB_query("UPDATE {$_TABLES['plugins']} SET pi_homepage='http://geeklog.fr' WHERE pi_name='paypal",1);
			
		case '1.0' :			
			require_once $_CONF['path'] . 'plugins/paypal/install_defaults.php';
			require_once $_CONF['path_system'] . 'classes/config.class.php';
			
			$c = config::get_instance();
			//This is main subgroup #0
			$c->add('sg_main', NULL, 'subgroup', 0, 0, NULL, 0, true, 'paypal');
			
			//Main settings   
			$c->add('fs_main', NULL, 'fieldset', 0, 0, NULL, 0, true, 'paypal');
			$c->add('paypal_folder', $_PAY_DEFAULT['paypal_folder'],
					'text', 0, 0, 0, 1, true, 'paypal');
			$c->add('menulabel', $_PAY_DEFAULT['menulabel'],
					'text', 0, 0, 0, 2, true, 'paypal');
			$c->add('paypal_login_required', $_PAY_DEFAULT['paypal_login_required'],
					'select', 0, 0, 3, 12, true, 'paypal');
			$c->add('hide_paypal_menu', $_PAY_DEFAULT['hide_paypal_menu'],
					'select', 0, 0, 3, 13, true, 'paypal');
			$c->add('paypalURL', $_PAY_DEFAULT['paypalURL'],
					'text', 0, 0, 0, 23, true, 'paypal');
			$c->add('receiverEmailAddr', $_PAY_DEFAULT['receiverEmailAddr'],
					'text', 0, 0, 0, 24, true, 'paypal');
			$c->add('currency', $_PAY_DEFAULT['currency'],
					'select', 0, 0, 20, 33, true, 'paypal');
			$c->add('anonymous_buy', $_PAY_DEFAULT['anonymous_buy'],
					'select', 0, 0, 3, 35, true, 'paypal');
			$c->add('purchase_email_user', $_PAY_DEFAULT['purchase_email_user'],
					'select', 0, 0, 3, 47, true, 'paypal');
			$c->add('purchase_email_user_attach', $_PAY_DEFAULT['purchase_email_user_attach'],
					'select', 0, 0, 3, 49, true, 'paypal');
			$c->add('purchase_email_anon', $_PAY_DEFAULT['purchase_email_anon'],
					'select', 0, 0, 3, 51, true, 'paypal');
			$c->add('purchase_email_anon_attach', $_PAY_DEFAULT['purchase_email_anon_attach'],
					'select', 0, 0, 3, 53, true, 'paypal');
			$c->add('maxPerPage', $_PAY_DEFAULT['maxPerPage'],
					'text', 0, 0, 0, 63, true, 'paypal');
			$c->add('categoryColumns', $_PAY_DEFAULT['categoryColumns'],
					'text', 0, 0, 0, 65, true, 'paypal');
			//images
            $c->add('fs_images', NULL, 'fieldset', 0, 1, NULL, 0, true, 'paypal');
		    $c->add('max_images_per_products', $_PAY_DEFAULT['max_images_per_products'],
                'text', 0, 1, 0, 1, true, 'paypal');
		    $c->add('max_image_width', $_PAY_DEFAULT['max_image_width'],
                'text', 0, 1, 0, 2, true, 'paypal');
		    $c->add('max_image_height', $_PAY_DEFAULT['max_image_height'],
                'text', 0, 1, 0, 3, true, 'paypal');
		    $c->add('max_image_size', $_PAY_DEFAULT['max_image_size'],
                'text', 0, 1, 0, 4, true, 'paypal');
		    $c->add('max_thumbnail_size', $_PAY_DEFAULT['max_thumbnail_size'],
                'text', 0, 1, 0, 5, true, 'paypal');
					
			//This is display subgroup #1
			$c->add('sg_display', NULL, 'subgroup', 1, 0, NULL, 0, true, 'paypal');
			
			// Display settings
			$c->add('fs_display', NULL, 'fieldset', 1, 8, NULL, 0, true, 'paypal');
			$c->add('paypal_main_header', NULL, 'text', 1, 8, 0, 2, true, 'paypal');
			$c->add('paypal_main_footer', NULL, 'text', 1, 8, 0, 4, true, 'paypal');

        default :
		    //Perform db updates 
			if (isset($_UPDATES[$currentVersion])) {
                $_SQL = $_UPDATES[$currentVersion];
                foreach ($_SQL as $sql) {
                    DB_query($sql);
                    COM_errorLog( "Updated paypal plugin with sql:  $sql", 1 );
                }
            }
			
			// update plugin version number
            $inst_parms = plugin_autoinstall_paypal('paypal');
            $pi_gl_version = $inst_parms['info']['pi_gl_version'];
            DB_query("UPDATE {$_TABLES['plugins']} SET pi_version = '$code_version', pi_gl_version = '$pi_gl_version' WHERE pi_name = 'paypal'");
	        COM_errorLog( "Updated paypal plugin from v$currentVersion to v$code_version", 1 );
    }
	
    return true;
}

/**
* Callback function when another plugin was installed/uninstalled/upgarded/
* enabled/disabled
*
* @param    string  $type   plugin name
* @param    string  $status 'installed', 'uninstalled', 'upgraded', 'enabled',
*                           or 'disabled'
* @return   void
* @see      PLG_pluginStateChange
*/
function plugin_pluginstatechange_paypal($type, $status)
{
    global $_CONF;

    switch ($status) {
        case 'installed':
            break;

        case 'uninstalled':
            break;

        case 'upgraded':
            break;

        case 'enabled':
        case 'disabled':
            break;
    }

}

/**
* Automatic uninstall function for plugins
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
* @return   array   Plugin information
*
*/
function plugin_autouninstall_paypal()
{
    global $_PAY_CONF;
	
    $out = array (
        /* give the name of the tables, without $_TABLES[] */
        'tables' => array('paypal_ipnlog','paypal_downloads','paypal_products','paypal_purchases','paypal_images','paypal_categories'), 
        /* give the full name of the group, as in the db */
        'groups' => array('Paypal Admin', 'Paypal User', 'Paypal Viewer'),
        /* give the full name of the feature, as in the db */
        'features' => array('paypal.admin', 'paypal.user', 'paypal.viewer'),
        /* give the full name of the block, including 'phpblock_', etc */
        'php_blocks' => array('phpblock_paypal_cart'),
        /* give all vars with their name */
        'vars' => array()
    );
	
	if (file_exists($_PAY_CONF['logfile'])) {
        @unlink($_PAY_CONF['logfile']);
	}

    return $out;
}

/**
 * Checks to see if the user has sufficient rights to view the page
 *
 * Check if the current user has rights (at least one of) specified by $rights.  If not log the
 * error, display a generic access denied message and exit.
 *
 * @param $rights string comma seperated list of allowable rights
 */
function paypal_access_check($rights = 'paypal.user,paypal.admin,paypal.view') {
    global $_USER, $_SERVER, $LANG_PAYPAL_1, $_PAY_CONF;

    // Confirm that the user has sufficient rights to access this page
    if ($_USER['uid'] < 2 && $_PAY_CONF['paypal_login_required'] == 1) {
        $display .= COM_siteHeader();
		if (SEC_hasRights('paypal.user', 'paypal.admin')) {
            $display .= paypal_user_menu();
        } else {
            $display .= paypal_viewer_menu();
        }
        $display .= COM_startBlock($LANG_PAYPAL_1['access_reserved']);
        $display .= $LANG_PAYPAL_1['you_must_log_in'];
        $display .= COM_endBlock();
        $display .= COM_siteFooter(1);
        COM_output($display);
        exit;
    }
	
	// Confirm that the user has sufficient rights to access this page
    if (!SEC_hasRights($rights, 'OR')) {
        $display .= COM_siteHeader();
			if (SEC_hasRights('paypal.user', 'paypal.admin')) {
            $display .= paypal_user_menu();
        } else {
            $display .= paypal_viewer_menu();
        }
        $display .= COM_startBlock($LANG_PAYPAL_1['access_denied']);
        $display .= $LANG_PAYPAL_1['access_denied_message'];
        $display .= COM_endBlock();
        $display .= COM_siteFooter(1);
        COM_accessLog("Unauthorized user {$_USER['username']} from IP {$_SERVER['REMOTE_ADDR']} "
                    . 'attempted to access the paypal plugin at ' . $_SERVER['REQUEST_URI']);
        COM_output($display);
        exit;
    }
}

/**
 * Returns viewer menu display
 *
 * Generates the viewer menu from the template and returns the result as a string of HTML
 *
 * @return string HTML of viewer menu
 */
function paypal_viewer_menu() {
    global $_CONF, $_PAY_CONF, $LANG_PAYPAL_1;

    $display = COM_startBlock();

    // generate the menu from the template
    $menu = new Template($_CONF['path'] . 'plugins/paypal/templates');
    $menu->set_file(array('menu' => 'viewer_menu.thtml'));
    $menu->set_var('site_url', $_PAY_CONF['site_url']);
    $menu->set_var('homepage_label', $LANG_PAYPAL_1['homepage_label']);
    $menu->set_var('product_list_label', $LANG_PAYPAL_1['product_list_label']);
    $display .= $menu->parse('output', 'menu');

    $display .= COM_endBlock();

    // return results
    return $display;
}

/**
 * Returns user menu display
 *
 * Generates the user menu from the template and returns the result as a string of HTML
 *
 * @return string HTML of user menu
 */
function paypal_user_menu() {
    global $_CONF, $_PAY_CONF, $LANG_PAYPAL_1;

    $display = COM_startBlock();

    // generate the menu from the template
    $menu = new Template($_CONF['path'] . 'plugins/paypal/templates');
    $menu->set_file(array('menu' => 'user_menu.thtml'));
    $menu->set_var('site_url', $_PAY_CONF['site_url']);
    $menu->set_var('homepage_label', $LANG_PAYPAL_1['homepage_label']);
    $menu->set_var('product_list_label', $LANG_PAYPAL_1['product_list_label']);
    $menu->set_var('purchase_history', $LANG_PAYPAL_1['purchase_history']);
    $menu->set_var('view_cart', $LANG_PAYPAL_1['view_cart']);
    $menu->set_var('paypal_url', 'https://' . $_PAY_CONF['paypalURL']);
    $menu->set_var('business', $_PAY_CONF['receiverEmailAddr']);
	if (SEC_hasRights('paypal.admin')) {
        $menu->set_var('admin', ' | ' . '<a href="' . $_CONF['site_url'] . '/admin/plugins/paypal/index.php">' . $LANG_PAYPAL_1['admin'] . '</a>');
    } else {
	    $menu->set_var('admin', '');
	}
    $display .= $menu->parse('output', 'menu');

    $display .= COM_endBlock();

    // return results
    return $display;
}

/**
 * Returns admin menu display
 *
 * Generates the admin menu from the template and returns the result as a string of HTML
 *
 * @return string HTML of admin menu
 * @todo add support for pending (physical) transaction, not fully implemented
 */
function paypal_admin_menu() {
    global $_CONF, $_PAY_CONF, $_TABLES, $LANG_PAYPAL_1;

    $display = COM_startBlock();

    // generate the menu from the template
    $menu = new Template($_CONF['path'] . 'plugins/paypal/templates');
    $menu->set_file(array('menu' => 'admin_menu.thtml'));
    $menu->set_var('site_url', $_CONF['site_url']);
	$menu->set_var('paypal_url', $_PAY_CONF['site_url']);
    $menu->set_var('homepage_label', $LANG_PAYPAL_1['homepage_label']);
    $menu->set_var('store', $LANG_PAYPAL_1['store']);
    $menu->set_var('product_list_label', $LANG_PAYPAL_1['product_list_label']);
    $menu->set_var('new_product', $LANG_PAYPAL_1['new_product']);
    $menu->set_var('purchase_history', $LANG_PAYPAL_1['purchase_history']);
    $menu->set_var('view_IPN_log', $LANG_PAYPAL_1['view_IPN_log']);
    /**
     * @todo add support for pending transaction, not fully implemented
     */
    //$cnt = DB_count($_TABLES['paypal.purchases'], 'status', 'pending');
    //if ( $cnt <= 0 ) {
    //    $menu->set_var('pending', 'style="display: none" ');
    //} else {
    //    $menu->set_var('pending', '');
    //}

    $display .= $menu->parse('output', 'menu');

    $display .= COM_endBlock();

    // return results
    return $display;
}

/**
 * Filters submitted variables
 *
 * Uses geeklog functions to filter submitted variables for illegal content.  Any editing is
 * done in place and no value is returned
 *
 * @param array $vars associative array of variable name => type (type in (number,alpha,text,html))
 * @param array &$arr reference to associative array of variable name => value
 */
function paypal_filterVars($vars, &$arr) {
    // cycle through each variable applying the appropriate filter
    foreach ($vars as $var => $type) {
        switch ($type) {
            case 'number':
                $arr[$var] = COM_applyFilter($arr[$var], true);
                break;

            case 'html':
                $arr[$var] = COM_checkHTML($arr[$var], 'paypal.admin');
                break;

            case 'text':
                $arr[$var] = htmlspecialchars(strip_tags(COM_stripslashes($arr[$var])));
                break;

            case 'alpha':
            default:
                $arr[$var] = COM_applyFilter($arr[$var], false);
                break;
        }
    }
}

/**
 * Send out an email with (possibly) an attachment
 *
 * This function is needed because geeklog's built in mail function does not allow adding
 * attachments to outgoing email, this function does exactly that
 *
 * @param  to           string   recipients name and email address
 * @param  subject      string   subject of the email
 * @param  message_text string   the text of the email
 * @param  attachments  array    array of file names (path included), to attach
 * @param  from         string   (optional) sender of the the email
 * @param  html         bool     true if to be sent as an HTML email
 * @return boolean               true if successful,  otherwise false
 */
function paypal_mailAttachment($to, $subject, $message_text, $attachments = array(),
                               $from = '', $html = true) {
    global $_CONF, $LANG_CHARSET;

    static $mailobj;

    include_once( 'Mail.php' );
    include_once( 'Mail/RFC822.php' );

    $method = $_CONF['mail_settings']['backend'];

    if( !isset( $mailobj )) {
        if(( $method == 'sendmail' ) || ( $method == 'smtp' )) {
            $mailobj =& Mail::factory( $method, $_CONF['mail_settings'] );
        } else {
            $method = 'mail';
            $mailobj =& Mail::factory( $method );
        }
    }

    if( empty( $LANG_CHARSET )) {
        $charset = $_CONF['default_charset'];
        if( empty( $charset )) {
            $charset = 'iso-8859-1';
        }
    } else {
        $charset = $LANG_CHARSET;
    }

    if( empty( $from )) {
        $from = COM_formatEmailAddress( $_CONF['site_name'], $_CONF['site_mail']);
    }

    $headers = array();

    $headers['From'] = $from;
    if( $method != 'mail' ) {
        $headers['To'] = $to;
    }
    $headers['Date'] = date( 'r' ); // RFC822 formatted date
    if( $method == 'smtp' ) {
        list( $usec, $sec ) = explode( ' ', microtime());
        $m = substr( $usec, 2, 5 );
        $headers['Message-Id'] = '<' .  date( 'YmdHis' ) . '.' . $m
                               . '@' . $_CONF['mail_settings']['host'] . '>';
    }
    $headers['Subject'] = $subject;
    $headers['X-Mailer'] = 'geeklog ' . VERSION;

    if (count($attachments) <= 0) {
        if( $html ) {
            $headers['Content-Type'] = 'text/html; charset=' . $charset;
            $headers['Content-Transfer-Encoding'] = '8bit';
        } else {
            $headers['Content-Type'] = 'text/plain; charset=' . $charset;
        }
        $message = $message_text;
    } else {
        // Create MIME Boundary, set MIME relevant headers
        $mime_boundary = '==Mulipart_Boundary_x' . md5(time());
        $headers['MIME-Version'] = '1.0';
        $headers['Content-Type'] = "multipart/mixed;\n  boundary=\"$mime_boundary\"";

        // Create the message part of the message
        $message = "This is a multi-part message in MIME format.\n\n"
                 . "--$mime_boundary\n";
        if( $html ) {
            $message .= "Content-Type:text/html; charset=i\"$charset\"\n";
            $message .= "Content-Transfer-Encoding: 8bit\n\n";
        } else {
            $message .= "Content-Type:text/plain; charset=i\"$charset\"\n";
            $message .= "Content-Transfer-Encoding: 7bit\n\n";
        }
        $message .= $message_text . "\n\n";

        // Add attachments
        foreach ($attachments as $file) {
            // get file
            $fileh = fopen($file,'rb');
            $data  = fread($fileh,filesize($file));
            fclose($fileh);
            $filename = basename($file);

            // encode data
            $data = chunk_split(base64_encode($data));

            // Add attachment to message
            $message .= "--$mime_boundary\n" . "Content-Type: application/octet-stream;\n"
                      . "Content-Disposition: attachment;\n  filename=\"$filename\"\n"
                      . "Content-Transfer-Encoding: base64\n\n" . $data . "\n\n";
        }

        $message .= "--$mime_boundary--\n";
    }

    $retval = $mailobj->send( $to, $headers, $message );
    if( $retval !== true ) {
        COM_errorLog( $retval->toString(), 1 );
    }

    return( $retval === true ? true : false );
}

/**
 * Manually generate different types of buttons
 *
 * @param string $type Type of button to generate (donation, subscribe, buy_now, add_to_cart)
 * @param array  $vars Associative array of input variables, contents depend on type of button,
 *                     include: (name, id, price, business, user_id, count, type)
 * @return string      HTML of requested button
 */
function paypal_genButton($type, $vars) {
    global $_CONF, $_USER;

    // must be an expected type
    if ( $type != 'donation' && $type != 'subscribe' &&
         $type != 'buy_now' && $type != 'add_to_cart' ) {
        return false;
    }

    $button = new Template($_CONF['path'] . 'plugins/paypal/templates');
    $button->set_file(array('button'   => "{$type}_button.thtml"));

    $button->set_var('site_url', $_CONF['site_url']);
    $button->set_var('paypal_url', 'https://' . $_PAY_CONF['paypalURL']);

    if (empty($vars['user_id'])) {
        $button->set_var('user_id', $_USER['uid']);
    } else {
        $button->set_var('user_id', $vars['user_id']);
    }
    if (empty($vars['business'])) {
        $button->set_var('business', $_PAY_CONF['receiverEmailAddr'][0]);
    } else {
        $button->set_var('business', $vars['business']);
    }

    $button->set_var('id', $vars['id']);
    $button->set_var('name', $vars['name']);
    $button->set_var('price', $vars['price']);
    $button->set_var('count', $vars['count']);
    $button->set_var('type', $vars['type']);
	$button->set_var('return', $vars['return']);

    return $button->parse('output', 'button');
}

function PAYPAL_displayCart ($block=0)
{
    global $_CONF, $_PAY_CONF, $jcart;

	include_once ($_CONF['path'] . 'plugins/paypal/paypal.php');

    // Start session
    session_start();

    // Initialize jcart after session start
    $cart =& $_SESSION["jcart"];
    if(!is_object($cart)) $cart = new jcart();
	$retval = $cart->display_cart($jcart,$block);
	
    return $retval;
}

/**
*   Create a random product block.
*   Shows a single product selected from all enabled products.
*
*   @param  string  $cat    Optional single category
*   @return                 HTML for the block
*/
function phpblock_paypal_cart ()
{
    $retval = '<small>' . PAYPAL_displayCart(1) . '</small>';

    return $retval;
}

/**
* Geeklog informs us that we're about to be enabled or disabled
*
* @param    boolean     $enable     true = we're being enabled, false = disabled
* @return   void
*
*/
function plugin_enablestatechange_paypal ($enable)
{
    global $_TABLES;

    $is_enabled = $enable ? 1 : 0;

    // toggle paypal block
    DB_query ("UPDATE {$_TABLES['blocks']} SET is_enabled = $is_enabled WHERE (type = 'phpblock') AND (phpblockfn = 'phpblock_paypal_cart')");
}

function phpblock_PAYPAL_displayProducts ()
{
    $retval = PAYPAL_displayProducts();
    return $retval;
}

function PAYPAL_displayProducts ()
{
    global $_CONF, $_PAY_CONF, $LANG_PAYPAL_1, $_TABLES, $_REQUEST, $_USER;
	
$retval = COM_startBlock();

// Display categories
if (isset( $_PAY_CONF['categoryColumns']) && $_PAY_CONF['categoryColumns'] > 0) {
    $sql = "SELECT category, count(*) count FROM {$_TABLES['paypal_products']} WHERE category IS NOT NULL AND category <> '' GROUP BY category ORDER BY category";
    	$res = DB_query($sql);
    	$nrows = DB_numRows($res);
    	if ($nrows > 0) {
    	    $cat = new Template($_CONF['path'] . 'plugins/paypal/templates');
		    $cat->set_file(array('table'    => 'category_table.thtml',
							     'row'      => 'category_row.thtml',
							     'category' => 'category.thtml'));
		    $cat->set_var('width', floor (100 / $_PAY_CONF['categoryColumns']));
    		for ($i = 1; $i <= $nrows; $i++) {
    	    		$C = DB_fetchArray ($res);
					$cat->set_var('category_heading', $LANG_PAYPAL_1['category_heading']);
    	    		$cat->set_var('category_name', $C['category']);
    	    		$cat->set_var('category_link', $_PAY_CONF['site_url'] . '/index.php?category='. urlencode($C['category']));
    	    		$cat->set_var('count', $C['count']);
    	    		if ($C['category'] == $_REQUEST['category']) {
    	    		    $cat->set_var('curr', 'current');
    	    		} else {
    	    		    $cat->set_var('curr', 'other');
    	    		}
    	    		$cat->parse('catrow', 'category', true);
    	    		if ($i % $_PAY_CONF['categoryColumns'] == 0) {
    	    			$cat->parse('categories', 'row', true);
    	    			$cat->set_var('catrow', '');
    	    		}
	    	}
	    	if ($nrows % $_PAY_CONF['categoryColumns'] != 0) {
    	    		$cat->parse('categories', 'row', true);
    	    }
	    	$retval .= $cat->parse('', 'table');
    	}
}


// Get products from database
$sql = "SELECT p.id,p.name,p.short_description,p.price,p.download, p.logged,i.pi_filename
        FROM {$_TABLES['paypal_products']} AS p
        LEFT JOIN {$_TABLES['paypal_images']} AS i
        ON i.pi_pid = p.id AND i.pi_img_num IN (SELECT MIN(pi_img_num) FROM {$_TABLES['paypal_images']} WHERE pi_img_num >= 1 AND pi_pid = p.id)  
		";

// If applicable, limit by category
if (isset( $_PAY_CONF['categoryColumns']) && $_PAY_CONF['categoryColumns'] > 0 &&
	!empty($_REQUEST['category']) ) {
	$sql .= " WHERE p.category = '{$_REQUEST['category']}'";
}

// If applicable, order by
if (!empty($_PAY_CONF['order'])) {
	$sql .= " ORDER BY {$_PAY_CONF['order']}";
}

// If applicable, handle pagination of query
if (isset($_PAY_CONF['maxPerPage']) && $_PAY_CONF['maxPerPage'] > 0) {
    // Count products from database
    $count = DB_count($_TABLES['paypal_products']);
    // Make sure page count is reasonable, if not, fix it
    if ($_REQUEST['page'] <= 0) {
        $_REQUEST['page'] = 1;
    }
    if ((($_REQUEST['page']-1) * $_PAY_CONF['maxPerPage']) > $count) {
        $_REQUEST['page'] = ceil($count / $_PAY_CONF['maxPerPage']);
    }
    // Add limit for pagination (if applicable)
    if ($count > $_PAY_CONF['maxPerPage']) {
        $sql .= ' LIMIT ' . ($_REQUEST['page']-1) * $_PAY_CONF['maxPerPage'] . ', ' . $_PAY_CONF['maxPerPage'];
    }
}

// query
$res = DB_query($sql);

// Create product template
$product = new Template($_CONF['path'] . 'plugins/paypal/templates');
$product->set_file(array('start'   => 'product_list_start.thtml',
                         'end'     => 'product_list_end.thtml',
                         'product' => 'product_list_item.thtml',
                         'buy'     => 'buy_now_button.thtml',
                         'cart'    => 'add_to_cart_button.thtml'));
$product->set_var('edit', '');
$product->set_var('site_url', $_PAY_CONF['site_url']);
$product->set_var('paypal_url', 'https://' . $_PAY_CONF['paypalURL']);
$product->set_var('user_id', $_USER['uid']);
$product->set_var('business', $_PAY_CONF['receiverEmailAddr']);
$product->set_var('price_label', $LANG_PAYPAL_1['price_label']);
$product->set_var('currency', $_PAY_CONF['currency']);


if (!empty($_REQUEST['category'])) {
    	$product->set_var('title', $_REQUEST['category']);
} else {
	$product->set_var('title', $LANG_PAYPAL_1['featured_products']);
}
$retval .= $product->parse('', 'start');

// Display each product
while ($A = DB_fetchArray($res)) {
    $product->set_var('id', $A['id']);
	$product->set_var('name', $A['name']);
    $product->set_var('link_name', '<a class="product-details" href="' . $_PAY_CONF['site_url'] . '/product_detail.php?product='. $A['id'] . '">' . $A['name'] . '</a>');
    $product->set_var('short_description', PLG_replacetags($A['short_description']));
    $product->set_var('price', $A['price']);
	$product->set_var('details', '<a class="product-details" href="' . $_PAY_CONF['site_url'] . '/product_detail.php?product='. $A['id'] . '">' . $LANG_PAYPAL_1['details'] . '</a>');

	//First product image	
	if ($A['pi_filename'] == '') {
		$product->set_var('small_pic', '');
	} else {
		$product->set_var('small_pic', '<a class="lightbox" href="' . $_PAY_CONF['site_url'] . '/images/products/' . $A['pi_filename'] . '"><img class="lightbox" src="'. $_PAY_CONF['site_url'] . '/timthumb.php?src=' . $_PAY_CONF['site_url'] . '/images/products/' . $A['pi_filename'] . '&amp;w='. $_PAY_CONF['thumb_width'] . '&amp;h='. $_PAY_CONF['thumb_height'] . '&amp;zc=1&amp;q=100" alt="' . $A['name'] . '" /></a>');
	}

	// FIXME: If a user purchased once with no expiration, this query will not operate correctly
	$time = DB_getItem($_TABLES['paypal_purchases'], 'MAX(UNIX_TIMESTAMP(expiration))',
					   "user_id = {$_USER['uid']} AND product_id = {$A['id']}");
	// Setup purchase links. If anonymous, ask for login. If free or purchased display
	// download link
	// For anymous users, login
	if (( $A['price'] > 0 && ($_USER['uid'] < 2 && $_PAY_CONF['anonymous_buy'] == 0)) || ($A['logged'] == 1 && $_USER['uid'] < 2)) {
		$loginlink = $_CONF['site_url'] . '/users.php';
		$createlink = $_CONF['site_url'] . '/users.php?mode=new';
		$product->set_var('buy_now', '');
		$product->set_var('add2cart', '');
		$product->set_var('link_name', $A['name']);
		$product->set_var('details', '');
		$product->set_var('login', "<small><a href=\"$loginlink\">" . $LANG_PAYPAL_1['login'] ."</a> " . $LANG_PAYPAL_1['or'] . " <a href=\"$createlink\">" . $LANG_PAYPAL_1['create_account'] . "</a> " . $LANG_PAYPAL_1['to_purchase'] . "</small>");
	// Free items or items purchases and not expired, download
	} else if ( $A['download'] > 0 && ( $A['price'] == 0 || $time > time() ) ) {
		$product->set_var('buy_now', '');
		$product->set_var('add2cart', '<a href="' . $_PAY_CONF['site_url'] . '/download.php'
								   . '?id=' . $A['id'] . '">' . $LANG_PAYPAL_1['Download'] . '</a>');
		$product->set_var('login', '');
	// buttons for everyone else
	} else {
		$product->set_var('buy_now_button', $LANG_PAYPAL_1['buy_now_button']);
		$product->set_var('buy_now', $product->parse('', 'buy'));
		$product->set_var('add_to_cart', $LANG_PAYPAL_1['add_to_cart']);
		$product->set_var('add2cart', $product->parse('', 'cart'));
		$product->set_var('login', '');
	}
	
	if (SEC_hasRights('paypal.admin')) {
	    $product->set_var('edit', "<form action=\"{$_CONF['site_url']}/admin/plugins/paypal/product_edit.php\" method=\"POST\"><div style=\"float:right;\"> <input type=\"image\" src=\"{$_CONF['site_url']}/paypal/images/edit.png\" name=\"id\" value=\"{$A['id']}\" align=\"middle\" /></div><input type=\"hidden\" name=\"op\" value=\"edit\" /></form>");
	}

	$retval .= $product->parse('', 'product');
}


// Display pagination
if ((isset($_PAY_CONF['maxPerPage'])) && ($_PAY_CONF['maxPerPage'] > 0) &&
        ($count > $_PAY_CONF['maxPerPage'])) {
    $product->set_var('pagination', COM_printPageNavigation($_PAY_CONF['site_url'] . '/index.php',
                                                            $_REQUEST['page'], ceil($count / $_PAY_CONF['maxPerPage'])));
} else {
    $product->set_var('pagination', '');
}

$retval .= $product->parse('', 'end');

$retval .= COM_endBlock();

return $retval;
}
?>