<?php
// +--------------------------------------------------------------------------+
// | PayPal Plugin - geeklog CMS                                             |
// +--------------------------------------------------------------------------+
// | product_detail.php                                                       |
// |                                                                          |
// | Product View.  Displays single product with details.                     |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | Copyright (C) 2005-2006 by the following authors:                        |
// |                                                                          |
// | Authors: Vincent Furia     - vinny01 AT users DOT sourceforge DOT net    |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | This program is free software; you can redistribute it and/or            |
// | modify it under the terms of the GNU General Public License              |
// | as published by the Free Software Foundation; either version 2           |
// | of the License, or (at your option) any later version.                   |
// |                                                                          |
// | This program is distributed in the hope that it will be useful,          |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with this program; if not, write to the Free Software Foundation,  |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.          |
// |                                                                          |
// +--------------------------------------------------------------------------+

/**
 * Product View.  Displays single product with details.
 *
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @copyright Vincent Furia 2005 - 2006
 * @package paypal
 * @todo Add more complex logic to decide link display between:  purchase, login, download
 */

/**
 * require core geeklog code
 */
require_once '../lib-common.php';

// Incoming variable filter
$vars = array('product' => 'number');
paypal_filterVars($vars, $_REQUEST);

$pid = $_REQUEST['product'];

// Ensure sufficient privs to read this page
if (($_USER['uid'] < 2) && ($_PAY_CONF['anonymous_buy'] == 0)) {
    $display .= COM_siteHeader();
	if (SEC_hasRights('paypal.user', 'paypal.admin')) {
        $display .= paypal_user_menu();
    } else {
        $display .= paypal_viewer_menu();
    }
    $display .= COM_startBlock($LANG_PAYPAL_1['access_reserved']);
    $display .= $LANG_PAYPAL_1['you_must_log_in'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    COM_output($display);
    exit;
}

if ($_PAY_CONF['anonymous_buy'] == 0) paypal_access_check('paypal.user');

// query database for product
$res = DB_query("SELECT * FROM {$_TABLES['paypal_products']} WHERE id = {$pid}");

// count number of returned results, if unexpected redirect to product list
if (DB_numRows($res) != 1) {
    echo COM_refresh($_PAY_CONF['site_url'] . '/index.php');
}

$A = DB_fetchArray($res);

if (($_USER['uid'] < 2) && ($A['logged'] == 1)) {
    $display .= COM_siteHeader();
	if (SEC_hasRights('paypal.user', 'paypal.admin')) {
        $display .= paypal_user_menu();
    } else {
        $display .= paypal_viewer_menu();
    }
    $display .= COM_startBlock($LANG_PAYPAL_1['access_reserved']);
    $display .= $LANG_PAYPAL_1['you_must_log_in'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    COM_output($display);
    exit;
}

$display = COM_siteHeader();
if (SEC_hasRights('paypal.user', 'paypal.admin')) {
    $display .= paypal_user_menu();
} else {
    $display .= paypal_viewer_menu();
}

$display .= COM_startBlock();

$product = new Template($_CONF['path'] . 'plugins/paypal/templates');
$product->set_file(array('product' => 'product_detail.thtml',
                         'buy'     => 'buy_now_button.thtml',
                         'cart'    => 'add_to_cart_button.thtml'));
$product->set_var('site_url', $_CONF['site_url']);
$product->set_var('paypal_folder', $_PAY_CONF['site_url']);
if (SEC_hasRights('paypal.admin')) {
$product->set_var('edit', "<form action=\"{$_CONF['site_url']}/admin/plugins/paypal/product_edit.php\" method=\"POST\"><div style=\"float:right\">&nbsp; <input type=\"image\" src=\"{$_PAY_CONF['site_url']}/images/edit.png\" name=\"id\" value=\"{$A['id']}\" align=\"absmiddle\" /></div><input type=\"hidden\" name=\"op\" value=\"edit\" /></form>");
}else {
$product->set_var('edit', '');
}
$product->set_var('paypal_url', 'https://' . $_PAY_CONF['paypalURL']);
$product->set_var('user_id', $_USER['uid']);
$product->set_var('business', $_PAY_CONF['receiverEmailAddr']);
$product->set_var('currency', $_PAY_CONF['currency']);
$product->set_var('return', $_PAY_CONF['site_url'] . '/index.php?mode=endTransaction');
$product->set_var('cancel_return', $_PAY_CONF['site_url'] . '/index.php?mode=cancel');
$product->set_var('cbt', $LANG_PAYPAL_1['cbt'] . ' ' . $_CONF['site_name']);
$product->set_var('id', $A['id']);
$product->set_var('name', $A['name']);
$product->set_var('short_description', PLG_replacetags($A['short_description']));
$product->set_var('description', PLG_replacetags($A['description']));
$product->set_var('price_label', $LANG_PAYPAL_1['price_label']);
$product->set_var('price', $A['price']);

//images
$icount = DB_count($_TABLES['paypal_images'],'pi_pid', $pid);
$size = $_PAY_CONF['max_thumbnail_size'];
if ($icount > 0) {
	$result_products = DB_query("SELECT * FROM {$_TABLES['paypal_images']} WHERE pi_pid = '". $pid ."' ORDER BY pi_img_num");
	for ($z = 1; $z <= $icount; $z++) {
		$I = DB_fetchArray($result_products);

		$saved_images .= '<a class="lightbox" href="' .  $_PAY_CONF['site_url'] . '/images/products/' . $I['pi_filename'] . '"><img src="' . $_PAY_CONF['site_url'] . '/timthumb.php?src=' .  $_PAY_CONF['site_url'] . '/images/products/' . $I['pi_filename'] . '&amp;w=' . $size . '&amp;h=' . $size . '&amp;zc=1&amp;q=75" alt="' . $I['pi_filename'] . '" /></a> ';

	}
}
if ($icount == 0) {
	$product->set_var('pictures', '');
} else {
    $info_picture = '<p class="info_picture"><img src="' .  $_PAY_CONF['site_url'] . '/images/enlarge.png" alt="" align="absmiddle" /> ' . $LANG_PAYPAL_1['info_picture'] .'</p>';
	$product->set_var('pictures', '<div id="product-picture">' . $saved_images . $info_picture . '</div>');
}

// FIXME: If a user purchased once with no expiration query will not operate correctly
$time = DB_getItem($_TABLES['paypal_purchases'], 'MAX(UNIX_TIMESTAMP(expiration))',
                   "user_id = {$_USER['uid']} AND product_id = {$A['id']}");
// Setup purchase links. If anonymous, ask for login. If free or purchased display
// download link
/* For anymous users, login */
if ( ($A['price'] > 0) && ($_USER['uid'] == 1) && (!$_PAY_CONF['anonymous_buy'])) {
    $loginlink = $_CONF['site_url'] . '/users.php';
    $createlink = $_CONF['site_url'] . '/users.php?mode=new';
    $product->set_var('buy_now', "<a href=\"$loginlink\">Login</a> or <a href=\"$createlink\">"
                               . "Create an Account</a> to purchase");
    $product->set_var('add2cart', '');
	$product->set_var('add2cart2', '');
	$product->set_var('buy_now2', '');
/* Free items or items purchases and not expired, download */
} else if ( $A['download'] > 0 && ( $A['price'] == 0 || $time > time() ) ) {
    $product->set_var('buy_now', "<a href=\"{$_PAY_CONF['site_url']}/download.php"
                               . "?id={$A['id']}\">" . $LANG_PAYPAL_1['Download'] . "</a>");
    $product->set_var('add2cart', '');
	$product->set_var('add2cart2', '');
	$product->set_var('buy_now2', '');
/* buttons for everyone else */
} else {
    $product->set_var('buy_now_button', $LANG_PAYPAL_1['buy_now_button']);
	$product->set_var('add_to_cart', $LANG_PAYPAL_1['add_to_cart']);
    $product->set_var('buy_now', $product->parse('output', 'buy'));
    $product->set_var('add2cart', $product->parse('output', 'cart'));
    ($A['description'] == '') ? $product->set_var('add2cart2', '') : $product->set_var('buy_now2', $product->parse('output', 'buy'));
	($A['description'] == '') ? $product->set_var('buy_now2', '') : $product->set_var('add2cart2', $product->parse('output', 'cart'));
}

$display .= $product->parse('output', 'product');

//Display cart
$display .= '<div id="cart">' . PAYPAL_displayCart() .'</div>';

$display .= COM_endBlock();
$display .= COM_siteFooter(1);
 COM_output($display);

?>